10 '      Screenwriter with Graphics for the Osborne 1
20 '                    by Jack Walraven
30 '        2840 Leigh Road, Victoria, B. C., Canada
40 ' 
50 '  Jack  Walraven  is  the President of  the  Vancouver 
60 '  Island Osborne Group in Victora, Canada... Nice job!
70 ' 
80 '    Keyed in (meticulously) by Kelly Smith, CP/M-Net
90 ' 
100 ' From   articles  appearing  in  BOTH  'The  Portable 
110 ' Companion',  April/May  1983  (pages 53 to  55)  and 
120 ' 'Interface  Age',  June 1983 (pages  117,  132,  and 
130 ' 133)...the articles were essentially identical (both 
140 ' had the same bugs (line numbering was different!). I 
150 ' fixed  the  missing  end quotes in line  1180  ('The 
160 ' Portable  Companion'  version)  and  it  worked   as 
170 ' advertised!  Minor  changes to make sure that Jack's 
180 ' name appeared on screen at the program start, forced 
190 ' file write data to start at line 10000 in increments 
200 ' of 10, and renumbered the thing just for cleanup.
210 ' 
220 '                        - KS, CP/M-Net (805) 527-9321
230 ' 
240 '               Graphics Screenwriting
250 '
260 ' Designing  a  good-looking screen in MBASIC  is  not 
270 ' easy,  especially when incorporating block graphics.  
280 ' This  program enables you to draw text and  graphics 
290 ' on the screen using the arrow keys.  When the design 
300 ' is  complete,  press the RETURN or ENTER key and the 
310 ' program  generates an MBASIC  routine  automatically 
320 ' writing   the   READ,   POKE,   and  required   DATA 
330 ' statements.   The  saving  in  labor  and  time  are 
340 ' tremendous.
350 ' 
360 ' Based  on  a  similar program for  the  TRS-80  that 
370 ' creates  a  series  of PRINT  TAB  statements,  this 
380 ' program uses the POKE statement to display the block 
390 ' graphics on the screen.  The program sets the screen 
400 ' widow  parameters from video memory  location  61440 
410 ' (decimal)  to  64383,   to  prevent  wandering  past 
420 ' Osborne's 128 by 32 screen window.
430 ' 
440 '                  Drawing the Screen
450 ' 
460 ' The arrow keys are used to point and move the screen 
470 ' cursor  in  the  desired  direction.   Graphics  are 
480 ' generated  by pressing the ESC key to rotate through 
490 ' the various graphics characters;  press the TAB  key 
500 ' to  retain the one you like on the screen.   Keep it 
510 ' depressed to print it in the direction of the screen 
520 ' "arrow"  cursor.   Note that the cursor may also  be 
530 ' used to delete characters.
540 ' 
550 '                   Program Concepts
560 ' 
570 ' You  may  wonder how the screen  design  program  is 
580 ' generated  and saved.   When the design is finished, 
590 ' pressing  the  RETURN  (or ENTER)  key  PEEKs  video 
600 ' memory   by  noting  the  location  and  the   ASCII 
610 ' (American Standard Code for Information Interchange) 
620 ' code of that character.   A "dim block" character is 
630 ' traced  over each screen graphic symbol or character 
640 ' and  the information is stored in a DATA  statement.  
650 ' The actual video memory location is not saved as  it 
660 ' would take up too much diskette space.   Instead, it 
670 ' records  the increments between memory locations for 
680 ' higher effiency.  When the routine has been written, 
690 ' it is saved as an ASCII formatted sequential  access 
700 ' file  (the default filename is TEST.BAS),  with  the 
710 ' necessary  commands required to recall  your  screen 
720 ' graphics display.   The program can be run by itself 
730 ' or merged into another program;  however,  make sure 
740 ' the  line  numbers are different as the merged  file 
750 ' lines  will  replace  the  corresponding  lines   in 
760 ' memory.   Use RENUM if necessary.  In order to write 
770 ' the  sequential  file to the B  drive,  change  line 
780 ' number 1390 to:
790 ' 
800 '                   F$="B:"+F$+"BAS"
810 ' 
820 ' The  command to merge your graphics display file  is 
830 ' simply:
840 ' 
850 '                  MERGE"FILENAME<cr>
860 ' 
870 ' or
880 ' 
890 '                 MERGE"B:FILENAME<cr>
900 ' 
910 ' if it's located on the B drive.  Only files saved in 
920 ' ASCII format (i.e.,  SAVE"FILENAME",A<cr>) like this 
930 ' program may be merged.
940 ' 
950 '          MBASIC is a trademark of Microsoft
960 '      TRS-80 is a trademark of Tandy Corporation
970 ' 
980 PRINT CHR$(26) ' clear screen
990 CLEAR
1000 DIM PR$(100)
1010 B=61440!:E=64383!
1020 Z=B
1030 C=83
1040 RM=999:LM=999
1050 SP=32
1060 PRINT CHR$(26) ' clear screen
1070 PRINT:PRINT
1080 PRINT "         - Sceen Writer by Jack Walraven -"
1090 PRINT
1100 PRINT "       Cursor Control and Alph-Numeric Entry"
1110 PRINT
1120 PRINT "Use the arrow keys to move the cursor to the desired" 
1130 PRINT "position.   The  cursor will show what direction  it" 
1140 PRINT "will  move.   Use the alpha-numeric keys to lay  out" 
1150 PRINT "the screen format and message."
1160 PRINT
1170 PRINT "                      Graphics"
1180 PRINT
1190 PRINT "Use  the ESC key to produce the graphics you desire."  
1200 PRINT "Use the TAB key to continue drawing the graphics  in" 
1210 PRINT "the direction you indicated with the arrow keys."
1220 PRINT
1230 PRINT "When  your design is completed,  hit the ENTER  key."  
1240 PRINT "The  program  will then read your design into  video" 
1250 PRINT "memory,  write  a  BASIC program and save  it  in  a" 
1260 PRINT "sequential file, which you can the MERGE with any of" 
1270 PRINT "your  programs (just make sure that the line numbers" 
1280 PRINT "don't overlap)."
1290 PRINT:INPUT "Press any key to begin...",Y$
1300 PRINT CHR$(26) ' clear screen
1310 INPUT "Enter the beginning line number (default is 10000): ",LN
1320 PRINT CHR$(26) ' clear screen
1330 IF LN=0 THEN LN=10000
1340 INPUT "Enter the line number increment (default is 10): ",IC
1350 PRINT CHR$(26) ' clear screen
1360 IF IC=0 THEN IC=10
1370 INPUT "Filename (default is TEST): ",F$
1380 IF F$="" THEN F$="TEST"
1390 F$=F$+".BAS"
1400 PRINT CHR$(26) ' clear screen
1410 ' remove cursor from screen
1420 POKE Z+128,SP
1430 POKE Z,C
1440 ' wait for keyboard input
1450 A$=INKEY$:IF A$="" THEN 1450
1460 ' check if input is arrow key
1470 IF A$=CHR$(13) THEN POKE Z,SP:GOTO 2020
1480 IF A$=CHR$(11) THEN C=94:GOTO 1660
1490 IF A$=CHR$(10) THEN C=118:GOTO 1740
1500 IF A$=CHR$(12) THEN C=62:GOTO 1820
1510 IF A$=CHR$(8) THEN C=60:GOTO 1920
1520 A=ASC(A$)
1530 IF X>31 THEN X=0
1540 ' check if input is graphic
1550 IF A =27 THEN A=X:X1=X:X=X+1:POKE Z,A:GOTO 1450
1560 IF A=9 THEN A=X1
1570 Z1=Z-61440!:IF C=62 AND (Z1-50)/128=INT((Z1-50)/128) THEN POKE Z,A:GOTO 1450
1580 IF C=60 AND Z1/128=INT(Z1/128) THEN POKE Z,A:GOTO 1450
1590 POKE Z,A
1600 IF C=94 AND Z-127>B THEN Z=Z-128:GOTO 1450
1610 IF C=118 AND Z+128<E THEN Z=Z+128:GOTO 1450
1620 IF C=62 AND Z+1<E THEN Z=Z+1:GOTO 1450
1630 IF C=60 AND Z>B THEN Z=Z-1:GOTO 1450
1640 GOTO 1450
1650 ' cursor up routine
1660 IF Z-128<B THEN 1450
1670 IF C1<>C THEN 1700
1680 POKE Z,SP
1690 Z=Z-128
1700 C1=C
1710 POKE Z,C
1720 GOTO 1450
1730 ' cursor down routine
1740 IF Z+128>E GOTO 1450
1750 IF C1<>C THEN 1780
1760 POKE Z,SP
1770 Z=Z+128
1780 C1=C
1790 POKE Z,C
1800 GOTO 1450
1810 ' cursor right routine
1820 IF Z+1>E THEN 1450
1830 IF C1<>C THEN 1870
1840 Z1=Z-61440!:IF Z1=RM THEN 1450
1850 POKE Z,SP
1860 Z=Z+1
1870 C1=C
1880 Z1=Z-61440!:IF (Z1-50)/128=INT((Z1-50)/128) THEN RM=Z1
1890 POKE Z,C
1900 GOTO 1450
1910 ' cursor left routine
1920 IF Z-1<B THEN 1450
1930 IF C1<>C THEN 1970
1940 Z1=Z-61440!:IF Z1=LM THEN 1450
1950 POKE Z,SP
1960 Z=Z-1
1970 C1=C
1980 Z1=Z-61440!:IF Z1/128=INT(Z1/128) THEN LM=Z1
1990 POKE Z,C
2000 GOTO 1450
2010 ' read screen and write basic program
2020 CU=1
2030 PR$(CU)=STR$(LN)+ " PRINT CHR$(26)":CU=CU+1:LN=LN+IC
2040 PR$(CU)=STR$(LN)+ " WHILE A<>32:Z1=Z:READ Z,A:Z=Z1+Z:POKE Z+61440!,A:WEND"
2050 CU=CU+1:LN=LN+IC
2060 N2=0
2070 FOR N=0 TO 2816 STEP 128
2080	FOR N1=N TO N+50
2090		Z=N1+61440!
2100		T%=PEEK(Z)
2110		IF T%=32 THEN 2190
2120		POKE N1+61440!,127
2130		Z%=N1-N2
2140		Z$=MID$(STR$(Z%),2):T$=MID$(STR$(T%),2)
2150		IF LEN(PR$)<50 THEN PR$=PR$+Z$+","+T$+",":GOTO 2180
2160		PR$(CU)=STR$(LN)+" DATA "+PR$+Z$+","+T$
2170		CU=CU+1:LN=LN+IC:PR$=""
2180		N2=N1
2190	NEXT N1
2200 NEXT N
2210 IF PR$="" THEN 2230
2220 PR$(CU)=STR$(LN)+" DATA "+PR$+"32,32"
2230 CU=CU+1:LN=LN+IC
2240 PR$(CU)=STR$(LN)+" Y$=INPUT$(1)"
2250 ' save file to disk
2260 OPEN "O",#1,F$
2270 FOR N=1 TO CU+1
2280	PRINT #1,PR$(N)
2290 NEXT N
2300 CLOSE #1
2310 PRINT CHR$(26) ' clear screen
2320 PRINT:PRINT "Your graphics file: ";F$;" has been saved to disk"
2330 END
 CLOSE #1
2310 PRINT CHR$(26) ' clear screen
2320 PRINT:PRINT "Your graphics file: ";F$;" has 