;                     OSZDEATH.ASM Version 1.0
;
;                          by Kelly Smith
; 
; Graphics  display  for the Osborne 1 computer,  to indicate  that 
; "messing around" with your computer is not to be treated lightly.
; 
; This  was  "knocked"  together early one Saturday  morning  while 
; playing  around  with Dave  Grenewetski's  OSBOARD  program...the 
; display took all of 1/2 hour to set-up...amazing.
; 
; Have fun with this one,  and best regards from Kelly Smith, CP/M-
; Net (805-527-9321) and Wizard of OsZ (213-709-6969).
;
	org	100h
;
bdos	equ	5	; bdos entry address
;
cr	equ	0dh	; carriage return
lf	equ	0ah	; line feed
esc	equ	01bh	; escape character
;
	jmp	start
;
msg:	db	esc,')'		; dim display

	db	cr,lf,'If  you  value  your  life as much  as  I  value  my'
	db	cr,lf,'Osborne 1 computer,              '
	db	esc,'('		; bright display
	db	esc,'l'		; begin underline
	db	'DON',027h,'T MESS WITH IT!'
	db	esc,'m'		; end underline
	db	'$'		; end of message	
;
brt$dsp:	db	esc,'($'		; bright display
;
dim$dsp:	db	esc,')$'		; dim display
;
clr:		db	'Z'-40h,'$'	; clear screen
;
grf$on:		db	esc,'g$'	; clear screen and graphics on
;
grf$off:	db	esc,'G$'	; graphics off
;
cr$lf:		db	cr,lf,'$'
;
start:	lxi	d,clr
	call	msgout
;
	lxi	d,grf$on
	call	msgout
;
	mvi	b,24
	mvi	c,52
	lxi	h,graphics
;
loop:	mov	a,m
	push	psw
	push	b
	push	h
	inx	h
	cpi	'$'
	jz	quit
	mov	a,m
	cpi	'D'	; dim display?
	lxi	d,brt$dsp
	jnz	brt
	lxi	d,dim$dsp
brt:	call	msgout
	pop	h
	pop	b
	pop	psw
;
	push	psw
	push	b
	push	h
	mov	e,a	; display graphics character
	mvi	c,2
	call	5
	pop	h
	pop	b
	pop	psw
;
	inx	h
	inx	h
	dcr	c
	jnz	loop
;
	push	psw
	push	b
	push	h
;
	lxi	d,grf$off
	call	msgout
;
	lxi	d,cr$lf
	call	msgout
;
	lxi	d,grf$on
	call	msgout
;
	pop	h
	pop	b
	pop	psw
	mvi	c,52
	dcr	b
	jnz	loop
;
quit:	lxi	d,grf$off	; graphics off, for ascii messages
	call	msgout
;
	lxi	d,msg	; print message
	call	msgout
;
exitchk:lxi	b,01000h; make a delay
	lxi	h,0f494h; point to eye #1
	lxi	d,0f49bh; point to eye #2
eyes:	mvi	m,'M'-40h	; make an eye
	mvi	a,'@'-40h	; make a wink
	stax	d	
	xchg		; swap "an eye for an eye"
	dcx	b	; do this for delay time to make eyes look wierd
	mov	a,b
	ora	c
	jnz	eyes
	mvi	a,'M'-40h	;restore both eyes
	mov	m,a
	stax	d
	lxi	b,04000h; make a delay
teeth:	dcx	b
	mov	a,b
	ora	c
	jnz	teeth
	lxi	h,0f715h; point to tooth #1
	lxi	d,0f71bh; point to tooth #2
	mov	a,m	; get tooth #1
	push	psw	; save on tos
	ldax	d	; get tooth #2
	mov	m,a	; replace old tooth with new tooth
	pop	psw	; get tos
	stax	d	; replace old tooth with new tooth
	mvi	c,6	; direct console i/o
	mvi	e,0ffh	; get console status
	call	bdos
	ora	a	; loop here if no character
	jz	exitchk
	jmp	start	; start over (ad nauseum)
;
msgout:	mvi	c,9	; print message ending with '$'
	call	bdos
	ret
;
graphics:		; start of graphics display
;
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,10,68,22,68,8,68,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,10,68,22,68,22,68,22,68
	db	8,68,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,10,68,10,68,22,68,22,68,8,68,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,10,68,22,68,22,68
	db	22,68,25,68,32,68,32,68,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,22,68,22,68,22,68,22,68,22,68,8,68
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,22,68
	db	22,68,22,68,8,68,22,68,8,68,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,21,68,22,68,22,68,8,68
	db	21,68,22,68,8,68,32,66,32,66,10,66,8,66,8,66,22,66,22,66
	db	22,66,22,66,22,66,22,66,8,66,32,66,32,66,32,66,32,66,32,66
	db	10,68,22,68,25,68,21,68,22,68,22,68,25,68,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,21,68
	db	25,68,32,68,32,66,21,68,22,68,8,68,10,66,22,66,10,66,22,66
	db	22,66,22,66,22,66,22,66,22,66,22,66,22,66,8,66,32,66,32,66
	db	32,66,10,68,22,68,25,68,32,68,32,68,32,68,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,68,32,66,32,66,21,68,10,66,22,66,22,66
	db	22,66,22,66,22,66,22,66,22,66,22,66,22,66,22,66,22,66,22,66
	db	8,66,32,66,10,68,22,68,25,68,32,68,32,68,32,68,32,68,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,68,32,68,10,66,22,66
	db	22,66,22,66,22,66,22,66,22,66,22,66,8,66,10,66,22,66,22,66
	db	22,66,22,66,22,66,8,66,22,68,25,68,32,68,32,68,32,68,32,68
	db	32,68,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,68,32,68
	db	22,66,22,66,22,66,22,66,22,66,22,66,22,66,22,66,22,66,22,66
	db	22,66,22,66,22,66,22,66,22,66,22,66,25,68,32,68,32,66,32,66
	db	32,68,32,68,32,68,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,22,66,22,66,25,66,32,66,32,66,32,66,21,66,22,66
	db	22,66,25,66,32,66,32,66,32,66,32,66,21,66,22,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,22,66,25,66,32,66,32,66,13,66,32,66
	db	10,66,22,66,22,66,8,66,32,66,13,66,32,66,32,66,32,66,22,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,22,66,8,66,32,66,32,66
	db	32,66,10,66,25,66,32,66,32,66,21,66,8,66,32,66,32,66,32,66
	db	32,66,22,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,21,66,22,66
	db	8,66,22,66,22,66,22,66,32,66,10,66,8,66,32,66,22,66,22,66
	db	22,66,10,66,10,66,25,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,21,66,22,66,22,66,22,66,22,66,8,66,22,66,22,66,10,66
	db	22,66,22,66,22,66,22,66,25,66,32,68,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,21,66,22,66,22,66,22,66,22,66
	db	22,66,22,66,25,66,22,66,25,66,21,68,22,68,8,68,32,68,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,10,68,32,66,25,66
	db	32,66,32,66,32,66,32,66,32,66,21,66,32,66,32,66,21,68,22,68
	db	8,68,32,68,32,66,32,68,10,68,8,68,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,10,68,22,68
	db	8,66,32,66,32,66,32,66,10,66,8,66,32,66,32,66,32,66,32,66
	db	32,66,21,68,22,68,8,68,32,68,32,68,22,68,22,68,10,68,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,10,68
	db	22,68,25,68,22,66,22,66,22,66,8,66,22,66,22,66,22,66,22,66
	db	32,66,32,66,32,66,32,66,21,68,22,68,8,68,10,68,22,68,22,68
	db	22,68,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,10,68,8,68
	db	10,68,22,68,25,68,32,66,21,66,22,66,10,66,22,66,22,66,22,66
	db	22,66,25,66,32,66,32,66,32,66,32,66,32,66,21,68,22,68,22,68
	db	22,68,22,68,25,68,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,10,68,22,68
	db	22,68,22,68,22,68,25,68,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	21,68,21,68,22,68,21,68,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	22,68,22,68,8,68,22,68,25,68,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,21,68,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,22,68,22,68,22,68,25,68,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,21,68,25,68,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	32,66,32,66,32,66,32,66,32,66,32,66,32,66,32,66
	db	'$'	; end of graphics display
;
;
;
	end
