; SETOKI.ASM  Version 1.2 - OKIDATA u84 Printer Utility - 21-August-83
; 
;                                by
; 
;                           Irvin M. Hoff
;                    Los Altos Hills, CA  94022
; 
; Revised to Version 1.2, 21-August-83 by Kelly Smith.  Added selection
; for Near Letter Quality (NLQ) function, with proportional spacing.
;
;        Version 1.1 Additions by Kelly Smith, CP/M-Net(tm)
;
;   Note: This version is for the OKIDATA u84 Microline Printer
;
; 
; This  program  sets an OKIDATA printer to various  configurations 
; such as:
; 
;              10, 12, or 17 characters/inch
;              6 or 8 vertical lines/inch
;              68, 81, 115, 136, 163, or 231 characters/line
; 
; There  are numerous other selections that could be  added.   This 
; program should give you the background to include other  options, 
; if desired, yourself.
;
;
;
;                             Usage
;
; This  simple  program allows OKIDATA users to preset a number  of 
; options.  The  printer can then be satisfactorily used  with  the 
; TYPE command (via CTRL-P) or other normal listing programs.
; 
; 
; These options include:  5, 6, 8.5, 10, 12, or 17 chars/inch
;                         68, 81, 115, 136, 163, or 231 chars/line
;                         6 or 8 vertical lines/inch
;                         emphasized print on/off
;                         underlined print on/off
;                         new line (cr/lf)
;                         top-of-form
;                         page eject 
;                         reset to normal default values
; 
; 
; To  use, turn on the Okidata printer and then call up SETOKI.COM.  
; It will display various options on its menu.   Several selections 
; can be made at the same time or a number reentered if  mis-typed.  
; 
; If  RETURN  is  immediately  typed  it  defaults  to  a  standard 
; configuration.
; 
; 
;             Default is:  10 characters per inch
;                          80 characters per line
;                           6 vertical lines per inch
; 
; 
; After  the  appropriate answers have been typed,  type RETURN  to 
; leave  the program (or CTRL-C).   The printer now has the options 
; you selected.
; 
; The TYPE command (via CTRL-P) may then be used or any other  LIST 
; routine desired.
; 
; Obviously some options were not included. The SETOKI.ASM file can 
; be  edited  and  then reassembled (ASM.COM works  fine  for  this 
; purpose).   Even  if the operator is not too familiar with  using 
; source  code,  there are enough examples already included to make 
; the job of adding some additional feature fairly simple.
; 
; 
; 
;                                  Irv Hoff
;                                  Los Altos Hill, CA  94022
;
;
; GENERAL EQU'S
;
TRUE    EQU   -1             ;DEFINE TRUE
FALSE   EQU   NOT TRUE       ;DEFINE FALSE
;
CLRSCN  EQU   TRUE           ;CLEAR SCREEN (IF TERMINAL CAN DO IT)
;
BDOS    EQU   5              ;SYSTEM CALL ENTRY POINT
;
CONIN   EQU   1              ;GET KEYBOARD CHARACTER
CONOUT  EQU   2              ;CRT OUTPUT ROUTINE
LIST    EQU   5              ;LIST DEVICE OUTPUT
STRING  EQU   9              ;PRINT STRING ON CONSOLE
;
CTLC    EQU   3              ;TO TERMINATE
TAB     EQU   09H            ;HORIZONTAOL TAB
LF      EQU   0AH            ;LINE FEED
FF      EQU   0CH            ;FORM FEED 
CR      EQU   0DH            ;CARRIAGE RETURN
ESC     EQU   1BH            ;ESCAPE CHARACTER
CLR     EQU   'Z'-40H        ;CLEAR SCREEN
;
;
;
        ORG   100H
;
        JMP   START          ;JUMP INTO PROGRAM
;
;
;
; Data strings to control OKIDATA u84 Microline Printer
;
DEFLT:  DB    01EH,ESC,'6',ESC,'I',ESC,'D',0 ;DEFAULT (PROGRAM AS DESIRED)
CN:     DB    01CH,ESC,'6',0             ;17 CPI, 6 LPI
MCN:    DB    01DH,ESC,'6',0             ;12 CPI, 6 LPI
UCN:    DB    01EH,ESC,'6',0             ;10 CPI, 6 LPI 
WN:     DB    01CH,01FH,ESC,'6',0        ;8.5 CPI, 6 LPI
MWN:    DB    01DH,01FH,ESC,'6',0        ;6 CPI, 6 LPI
UWN:    DB    01EH,01FH,ESC,'6',0        ;5 CPI, 6 LPI
NLQ:	DB    ESC,'1',0                  ;NEAR LETTER QUALITY FUNCTION
RESET:	DB    ESC,'0',0                  ;RESET (SELECT ORDINARY CHARACTER SET)
EMPHON: DB    ESC,'H',0                  ;EMPHASIZED ON
EMPHOF: DB    ESC,'I',0                  ;EMPHASIZED OFF
UNDRON: DB    ESC,'C',0                  ;UNDERLINE ON
UNDROF: DB    ESC,'D',0                  ;UNDERLINE OFF
EIGHT:  DB    ESC,'8',0                  ;8 LINES PER INCH
SIX:    DB    ESC,'6',0                  ;6 LINES PER INCH
TOF:    DB    FF,0                       ;TOP-OF-FORM
EJECT:  DB    FF,FF,0                    ;PAGE EJECT
TURNUP: DB    CR,LF,0,'$'                ;TURN UP NEW LINE
;
;
; SIGN-ON MESSAGE
;
SOM:    EQU   $

        IF    CLRSCN        ;IF CLEAR SCREEN OPTION
        DB    CLR
        DB    'OKIDATA u84 Printer Options - Version 1.2, 21-Aug-83'
        DB    CR,LF,LF
        ENDIF

        IF    NOT CLRSCN   ;IF NOT CLEAR SCREEN OPTION
        DB    CR,LF,LF,LF
        DB    'OKIDATA u84 Printer Options - Version 1.1, 13-Feb-83'
        ENDIF

        DB    CR,LF,LF,TAB,'A =   Reset to default parameters'
        DB    CR,LF,TAB,'B =   5 CPI, 6 LPI'
        DB    CR,LF,TAB,'C =   6 CPI, 6 LPI'
        DB    CR,LF,TAB,'D = 8.5 CPI, 6 LPI'
        DB    CR,LF,TAB,'E =  10 CPI, 6 LPI'
        DB    CR,LF,TAB,'F =  12 CPI, 6 LPI'
        DB    CR,LF,TAB,'G =  17 CPI, 6 LPI'
        DB    CR,LF,TAB,'H =   6 LPI'
        DB    CR,LF,TAB,'I =   8 LPI'
        DB    CR,LF,TAB,'J =   Emphasize On'
        DB    CR,LF,TAB,'K =   Emphasize Off'
        DB    CR,LF,TAB,'L =   Underline On'
        DB    CR,LF,TAB,'M =   Underline Off'
        DB    CR,LF,TAB,'N =   New Line' 
        DB    CR,LF,TAB,'O =   Top-of-Form (Form Feed)'
        DB    CR,LF,TAB,'P =   Page Eject'
        DB    CR,LF,TAB,'Q =   Near Letter Quality'
        DB    CR,LF,TAB,'R =   Reset (Ordinary Character Set)'
        DB    CR,LF,LF,TAB,'Select (A to R): '
        DB    '$'
;
;
;
START:  POP   H              ;RETURN ADDRESS TO 'CCP'
        SHLD  EXIT1+1        ;STORE
        LXI   SP,STACK       ;SET UP STACK
        LXI   D,SOM          ;SIGNON MESSAGE
        CALL  DSTRNG         ;SHOW ON THE CRT
        LXI   H,DEFLT        ;SET THE PRINTER TO NORMAL CONDITIONS
        JMP   PSTRNG
;
;
;
SELECT: CALL  INPUT          ;GET A CHARACTER
;
        CPI   'A'            ;RESET TO DEFAULT PARAMETERS
        LXI   H,DEFLT
        JZ    PSTRNG
;
        CPI   'B'
        LXI   H,UWN          ;5 CPI, 6 LPI
        JZ    PSTRNG
;
        CPI   'C'
        LXI   H,MWN          ;6 CPI, 6 LPI
        JZ    PSTRNG
;
        CPI   'D'
        LXI   H,WN           ;8 CPI, 6 LPI
        JZ    PSTRNG
;
        CPI   'E'
        LXI   H,UCN          ;10 CPI, 6 LPI
        JZ    PSTRNG
;
        CPI   'F'
        LXI   H,MCN           ;12 CPI, 6 LPI
        JZ    PSTRNG
;
        CPI   'G'
        LXI   H,CN           ;17 CPI, 6 LPI
        JZ    PSTRNG
;
        CPI   'H'
        LXI   H,SIX          ;GO TO 6 VERTICAL LINES PER INCH
        JZ    PSTRNG
;
        CPI   'I'
        LXI   H,EIGHT        ;GO TO 8 VERTICAL LINES PER INCH
        JZ    PSTRNG
;
        CPI   'J'
        LXI   H,EMPHON       ;EMPHASIZED ON
        JZ    PSTRNG
;
        CPI   'K'
        LXI   H,EMPHOF       ;EMPHASIZED OFF
        JZ    PSTRNG
;
        CPI   'L'
        LXI   H,UNDRON       ;UNDERLINE ON
        JZ    PSTRNG
;
        CPI   'M'
        LXI   H,UNDROF      ;UNDERLINE OFF
        JZ    PSTRNG
;
        CPI   'N'
        LXI   H,TURNUP       ;NEW LINE
        JZ    PSTRNG
;
        CPI   'O'
        LXI   H,TOF          ;TOP-OF-FORM
        JZ    PSTRNG
;
        CPI   'P'
        LXI   H,EJECT        ;PAGE EJECT
        JZ    PSTRNG
;
        CPI   'Q'
        LXI   H,NLQ          ;NEAR LETTER QUALITY
        JZ    PSTRNG
;
        CPI   'R'
        LXI   H,RESET        ;RESET (ORDINARY CHARACTER SET)
        JZ    PSTRNG
;
        JMP   SELECT         ;IF NONE OF THESE, ASK AGAIN
;
;
;
EXIT:   LXI   D,TURNUP       ;TURN UP SOME EXTRA LINES
        CALL  DSTRNG         ;DISPLAY ON THE CRT
;
EXIT1:  JMP   0              ;FILLED BY 'START' FOR RETURN TO 'CCP'
;
;
;
; GET A KEYBOARD CHARACTER
;
INPUT:  MVI   C,CONIN        ;KEYBOARD ROUTINE
        CALL  BDOS
        ANI   5FH            ;STRIP AWAY ANY PARITY AND FORCE TO UPPER CASE
        CPI   CTLC           ;CONTROL-C?
        JZ    EXIT           ;IF YES, ALL FINISHED
        CPI   CR             ;CONTROL-M FOR RETURN?
        JZ    EXIT           ;IF YES, ALL FINISHED
        RET
;
;
;
; DISPLAY A STRING ON THE CRT
;
DSTRNG: MVI   C,STRING       ;CONSOLE STRING ROUTINE
        JMP   BDOS           ;SEND TO THE CRT
;
;
;
; PRINT A STRING OF CHARACTERS ON THE PRINTER
;
PSTRNG: MOV   A,M            ;GET THE CHARACTER IN THE STRING
        ORA   A              ;SEE IF FINISHED YET
        JZ    SELECT         ;GET NEW ANSWER IF ZERO
;
        PUSH  H              ;SAVE THE ADDRESS IN THE STRING
        MVI   C,LIST         ;PRINTER ROUTINE
        MOV   E,A            ;PUT THE CHAR. INTO 'E' REG.
        CALL  BDOS           ;SEND TO THE PRINTER
        POP   H              ;BACK TO THE STRING ADDRESS
        INX   H              ;NEXT LOCATION
        JMP   PSTRNG         ;DO THE NEXT ONE
;
;
;
; STACK AREA
;
        DS	20H            ;ALLOW ROOM FOR STACK
;
STACK	DS	0
;
;
;
	END
